'Delete Linked Frames (by Abe Hendin)
'DeleteLinkedFrames.csc
'
'Copyright 2001-2002 by Abe Hendin <ventura@yourspeed.com>.
'Public Domain.
'Initial release, August 6, 2001.
'Revision 1.01, August 11, 2002: added basic error handling for no
'frame selection.
'Please let me know if you have ideas to improve on it, or if
'you discover bugs.
'
'This script deletes linked frames, starting with the currently-
'selected frame, and ending with the last linked frame in the series.
'It's very basic; one day I'll improve it along the lines of my
'InsertLinkedFrames" script, but for now it serves my needs.
'
'NOTE:
'For some reason yet unknown to me, the script sometimes fails to
'delete the final frame in the series.

WITHOBJECT "CorelVentura.Automation.10"

Dim FFirstInd As Integer, FNextInd As Integer
Dim FFirstPage As Integer, FNextPage As Integer
Dim retval As Integer

retval = MessageBox("Are you sure you want to delete all linked" + \\
	CHR(13) + "frames from the currently-selected frame to" + \\
	CHR(13) + "the end of the chapter?", \\
	"Delete Linked Frames to End of Chapter?", 4 Or 32)

If retval = 7 Then
	Stop
EndIf

DO
	'get the location info of the currently selected frame
	FFirstInd = .CurrentFrameIndex()
	FFirstPage = .CurrentPageNumber(, 2)
	
	ErrNum = 0
	On Error Resume Next
	.FrameNextLinked
	If ErrNum = 1001 Then
		retval = MessageBox("You must first select a linked frame!", \\
			"Error: No Frame Selected?", 48)
		Stop
	ElseIf ErrNum <> 0 Then
		retval = MessageBox("An unknown error has occurred.", \\
			"Unknown Error", 48)
		Stop
	End If
	
	FNextInd = .CurrentFrameIndex()
	FNextPage = .CurrentPageNumber(, 2)

	'check to see if we've reached the last frame in the series
	If FNextPage = FFirstPage Then
		.EditDelete
		Message "The last linked frame in the series has been deleted."
		Stop
	EndIf

	'return to the previously-selected frame and delete it
	.FramePrevLinked
	.EditDelete
	
	'go to next linked frame to repeat
	.ViewGotoPage .PageNumber = FNextPage, .GoWhere = 4
	.FrameFirst .FrameIndex = FNextInd
LOOP

END WITHOBJECT
